#ifndef AVR_HEXPROGRAM_H
#define AVR_HEXPROGRAM_H

#include "Program.h"
#include <fstream>

namespace avr {

	/**
	 * @author Tom Haber
	 * @date May 22, 2008
	 * @brief Support for the Intel Hex file format
	 *
	 * HexProgram is an implementation of a Program that
	 * can read Intel Hex format files as generated by
	 * avra and avr studio. This is usually also the format
	 * supplied to avrdude for programming.
	 */
	class HexProgram : public Program {
		public:
			HexProgram();
			HexProgram(const char *filename);
			~HexProgram();

		public:
			/**
			 * Opens and loads a file.
			 */
			void load(const char * filename);

			/**
			 * Reads the next available section from the file
			 * and returns the data in \e sec.
			 *
			 * \returns false if no further sections are available.
			 */
			bool readNextSection(Section & sec);

		private:
			void loadSymbols();

		private:
			std::ifstream f;
			bool end;
			unsigned int offset;
	};

	inline HexProgram::HexProgram() : end(true) {}
	inline HexProgram::HexProgram(const char *filename) : end(true) {
		load( filename );
	}

}

#endif /*AVR_HEXPROGRAM_H*/
